# About Sentinel and this RPM package

Dash Core Sentinel is a companion service adding functionality to Dash Core
Masternodes. If you are running the GUI client, or the Dash Core server as a
full node and not a masternode, then Sentinel and this document are irrelevant.

This packaged version of Sentinel assumes a few things about your masternode
configuration.

0. That the masternode is running as a systemd managed service. And therefore,
1. The masternode's `datadir` is located in /var/lib/dashcore
2. The masternode's dashd configuration file, `dash.conf`, is found in
   `/etc/dashcore/dash.conf` (symlinked to `/var/lib/dashcore/.dashcore/dash.conf`)
3. The masternode's sentinel configuration file, `sentinel.conf`, is found in
   `/etc/dashcore/sentinel.conf` (symlinked to `/var/lib/dashcore/sentinel/sentinel.conf`)
4. That Sentinel will run as system user `dashcore`

Therefore, if you intend to run multiple masternodes on one system. Or if you
are operating your masternode from a different data-directory and different
configuration file, this README does not articulate those scenarios.

----

# Using Sentinel

After setting up, configuring, and _fully syncing_ your masternode, you need to...

```
cd /var/lib/dashcore/sentinel && sudo -u dashcore SENTINEL_DEBUG=1 RPCHOST=127.0.0.1 RPCPORT=9998 RPCUSER=USERNAME_HERE RPCPASSWORD=PASSWORD_HERE ./venv/bin/python scripts/crontab.py
```

Seems to work? Then edit the dashcore system user's crontab...
```
sudo -u dashcore crontab -e
```

And within that editor, add this line:
```
* * * * * cd /var/lib/dashcore/sentinel && RPCHOST=127.0.0.1 RPCPORT=9998 RPCUSER=USERNAME_HERE RPCPASSWORD=PASSWORD_HERE ./venv/bin/python bin/sentinel.py >/dev/null 2>&1
```

# Good luck!

That's a minimalistic configuration.
For more information on this topic, please visit <https://docs.dash.org/en/stable/masternodes/setup.html>

Happy Masternoding! -t0dd
